#include <iostream>
#include "repcharstr.h"
#include <algorithm>
#include "repcharstr.h"

const int max = 1000;

int main()
{
  // 2-es
  basic_repeating_string<char> s;
  s.push_back( 'H' );
  s.push_back( 'i' );
  s.print( std::cout );
  std::endl( std::cout );

  basic_repeating_string<wchar_t> w;
  w.push_back( L'C' );
  w.push_back( L'+' );
  w.set_repeating( 2 );
  w.print( std::wcout );
  std::endl( std::wcout );

  basic_repeating_string<char> t;
  for( int i = 0; i < max; ++i )
  {
    t.push_back( 0 == i % 2 ? 'X' : 'Y' );
  }
  t.set_repeating( 3 );

  const basic_repeating_string<wchar_t> cw = w;
  w.print(std::wcout);std::endl( std::cout );
  w.push_back( L'+' );
  w.print(std::wcout);std::endl( std::cout );

std::cout<< 2  <<"=="<<  cw.rfind( L"++" )<<std::endl;
std::cout<< 2  <<"=="<<  s.size()<<std::endl;
std::cout<< -1  <<"=="<<  cw.rfind( L"+C" )<<std::endl;
std::cout<< 3 * max - 4  <<"=="<<  t.rfind( "XYY" )<<std::endl;
std::cout<< 3 * max  <<"=="<<  t.size()<<std::endl;
std::cout<< 2  <<"=="<<  w.size() - cw.size()<<std::endl;
  
  // 3-as
  s.set_repeating( 4 );
  s[ 6 ] = 'o';
  t[ 0 ] = 'T';

std::cout<< 1  <<"=="<<  t.rfind( "TT" )<<std::endl;
std::cout<< L'C'  <<"=="<<  cw[ 0 ]<<std::endl;
std::cout<< 0  <<"=="<<  w.compare( L"CC++++" )<<std::endl;
std::cout<< 0  <<"<"<<  cw.compare( L"BLABLA" )<<std::endl;
std::cout<< 0  <<">"<<  s.compare( "HI" )<<std::endl;
s.print();
std::cout<<std::endl<< 3  <<"=="<<  s.rfind( "Hoo" )<<std::endl;
  
   //4-es
  std::fill( s.begin(), s.end(), 'a' );
  basic_repeating_string<wchar_t>::iterator i = std::find( w.begin(), w.end(), L'+' );

std::cout<< (i != w.end())<<std::endl;
s.print();
std::cout<<std::endl<< 'a'  <<"=="<<  s[ 2 ]<<std::endl;
std::cout<< 4  <<"=="<<  s.rfind( "aaaa" )<<std::endl;

  
   //5-os
  basic_repeating_string<char> a;
  a.push_back( 'A' );
  a.push_back( 'T' );
  a.set_repeating( 3 );
  *(a.begin() ) = 'B';
  a[ 5 ] = 'O';

s.print();std::cout<<std::endl;
std::cout<< 8 <<"=="<< std::count( s.begin(), s.end(), 'a' )<<std::endl;
a.print();std::cout<<std::endl;
std::cout<<  "-3 == -"<<  std::count( a.begin(), a.end(), 'A' );
std::cout<<  "+ -"<<  std::count( a.begin(), a.end(), 'T' );
std::cout<<  "+ -"<<  std::count( a.begin(), a.end(), 'O' )<<std::endl;
  
}